#ifndef COLOR_X08R08G08B08I_h
#define COLOR_X08R08G08B08I_h

/*!
 	@file
 	@brief	１ピクセルをあらわすクラス郡
\n			XRGB8888 フォーマット Ver.
 */
#include"../../Setup/CompileMode.h"
#include"../../Auxiliary/Macro.h"

namespace Maid
{
	/*!
	 *	\class	COLOR_X08R08G08B08I COLOR_X08R08G08B08I.h
	 *	\brief	アルファなし３２ビットピクセル
	 */
	class COLOR_X08R08G08B08I
	{
	public:
		COLOR_X08R08G08B08I(){}	//!<	コンストラクタ
		COLOR_X08R08G08B08I( unt08 a, unt08 r, unt08 g, unt08 b ):m_Dumy(0xFF){ SetRGB( r, g, b ); }	//!<	コンストラクタ
		template <class COLOR>
		COLOR_X08R08G08B08I( const COLOR& Col ):m_Dumy(0xFF){ SetRGB( Col.GetR(), Col.GetG(), Col.GetB() ); }	//!<	コンストラクタ


		unt08 GetA() const	{ return 0xFF;		}	//!<	アルファ成分の取得
		unt08 GetR() const	{ return m_Red;		}	//!<	赤成分の取得
		unt08 GetG() const	{ return m_Green;	}	//!<	緑成分の取得
		unt08 GetB() const	{ return m_Blue;	}	//!<	青成分の取得

		operator unt32() const { return *((unt32*)&m_Blue); }	//!<	一括変換

		void SetA( unt08 a )	{ }					//!<	アルファ成分の設定
		void SetR( unt08 r )	{ m_Red   = r;	}	//!<	赤成分の設定
		void SetG( unt08 g )	{ m_Green = g;	}	//!<	緑成分の設定
		void SetB( unt08 b )	{ m_Blue  = b;	}	//!<	青成分の設定

		void SetRGB( unt08 r, unt08 g, unt08 b )	//!<	いっきに設定
		{
			SetR( r );
			SetG( g );
			SetB( b );
			m_Dumy = 0xFF;
		}

		//!	違うピクセルフォーマットとのコピー
		template <class PIXEL>
		COLOR_X08R08G08B08I& operator = (const PIXEL &src)
		{
			SetRGB(src.GetR(),src.GetG(),src.GetB());
			return *this;
		}

		//!	同じピクセルフォーマットとのコピー
		COLOR_X08R08G08B08I& operator = (const COLOR_X08R08G08B08I& src)
		{
			*(unt32*)(&m_Blue) = *(unt32*)(&src.m_Blue);
			return *this;
		}

	private:
		unt08 m_Blue;
		unt08 m_Green;
		unt08 m_Red;
		unt08 m_Dumy;
	};
}

#endif
